# Copyright (C) 2010 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
'''
Created on 2010-1-29

@author: tizhang <tiger.zhang@oracle.com>
'''
import unittest
import os,sys

sys.path.append(os.path.join(os.path.abspath(os.path.dirname(__file__)), '..'))
from OVSCDS import CDS, CDSLockTimeout

class Test(unittest.TestCase):


    def setUp(self):
        cds = CDS('cdstest') # cds will be destructed
    

    def tearDown(self):
        pass
    
    def testCDSRW(self):
        cds = CDS('cdstest')
        cds.db_cdstest['test'] = 'test'
        self.failUnlessEqual(cds.db_cdstest['test'], 'test')

    def testCDSLockTimeout(self):
        cds = CDS('cdstest')
        cds.db_cdstest['a'] = 'cds test'
        d1 = cds.db_cdstest['a']
        def open_again(dbname):
            cds2 = CDS(dbname)
        self.failUnlessRaises(CDSLockTimeout, open_again, 'cdstest')


if __name__ == "__main__":
    #import sys;sys.argv = ['', 'testCDSLockTimeout']
    # sys.argv = ['', '-v', ']
    unittest.main()