# Copyright (C) 2010 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
'''
Created on 2010-1-29

@author: tizhang <tiger.zhang@oracle.com>
'''
import unittest
import os, sys
from bsddb import db

sys.path.append(os.path.join(os.path.abspath(os.path.dirname(__file__)), '..'))
from OVSCDS import CDS, RoCDS

class Test(unittest.TestCase):


    def setUp(self):
        cds = CDS('rocdstest') # rocds will be destructed
        cds.db_rocdstest['a'] = 'rocds test'
        cds.close()


    def tearDown(self):
        pass


    def testRoCDSWriteError(self):
        rocds = RoCDS('rocdstest')
        def write_db(db):
            db.db_rocdstest['a'] = "rocds test"
        self.failUnlessRaises(db.DBAccessError, write_db, rocds)
        rocds.close()
    
    def testRoCDSRead(self):
        rocds = RoCDS('rocdstest')
        d1 = rocds.db_rocdstest['a']
        rocds2 = RoCDS('rocdstest')
        d2 = rocds2.db_rocdstest['a']
        self.failUnlessEqual(d1, 'rocds test')
        
    def testRoCDSNoFile(self):
        from datetime import datetime
        dbname = 'db_' + datetime.now().__str__() 
        rocds = RoCDS(dbname)


if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testRoCDS']
#    sys.argv = ['', '-v']
    unittest.main()